%define contentdir /var/www
%define logdir /var/log

Summary:	Squid proxy log analyzer and report generator
Name:		squidanalyzer
Version:	6.4
Release:	1
License:	GPLv3
Group:		Monitoring
Packager:	Django <django@mailserver.guru>
Distribution: 	CentOS 7
URL:		http://%{name}.darold.net/
Source:		http://prdownloads.sourceforge.net/squid-report/%{name}-%{version}.tar.gz
BuildRequires:	perl
BuildRequires:	perl-ExtUtils-MakeMaker, perl-ExtUtils-Install, perl-ExtUtils-Manifest, perl-ExtUtils-ParseXS, perl-Time-HiRes
BuildRequires:	gdbm-devel, libdb-devel, perl-devel, systemtap-sdt-devel
BuildArch:	noarch

Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n) 

%description
Squid proxy native log analyzer and reports generator with full
statistics about times, hits, bytes, users, networks, top URLs and
top domains. Statistic reports are oriented toward user and
bandwidth control; this is not a pure cache statistics generator.

SquidAnalyzer uses flat files to store data and doesn't need any SQL,
SQL Lite or Berkeley databases.

This log analyzer is incremental and should be run in a daily cron,
or more often with heavy proxy usage.

%prep

%setup -q

%build
perl Makefile.PL DESTDIR=%{buildroot} LOGFILE=%{logdir}/squid/access.log BINDIR=%{_bindir} HTMLDIR=%{contentdir}/%{name} BASEURL=/%{name} MANDIR=%{_mandir}/man3 QUIET=yes

make

%install
rm -rf %{buildroot}

make DESTDIR=%{buildroot} install
install etc/* %{buildroot}%{_sysconfdir}/%{name}/
install -d %{buildroot}%{_sysconfdir}/cron.daily
echo -e "#!/bin/sh\n%{_bindir}/squid-analyzer" > %{buildroot}%{_sysconfdir}/cron.daily/0%{name}


%files
%defattr(-,root,root)
%doc README ChangeLog
%{_mandir}/man3/*
%{perl_vendorlib}/SquidAnalyzer.pm
%attr(0755,root,root) %{_bindir}/squid-analyzer
%attr(0755,root,root) %{_libdir}/perl5/perllocal.pod
%attr(0755,root,root) %{_libdir}/perl5/vendor_perl/auto/SquidAnalyzer/.packlist
%attr(0755,root,root) %dir %{_sysconfdir}/%{name}
%attr(0664,root,root) %config(noreplace) %{_sysconfdir}/%{name}/%{name}.conf
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/%{name}/excluded
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/%{name}/included
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/%{name}/network-aliases
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/%{name}/user-aliases
%config(noreplace) %attr(0754,root,root) %{_sysconfdir}/cron.daily/0%{name}
%attr(0755,root,root) %dir %{_sysconfdir}/%{name}/lang
%{_sysconfdir}/%{name}/lang/*
%attr(0755,root,root) %dir %{contentdir}/%{name}
%{contentdir}/%{name}/flotr2.js
%{contentdir}/%{name}/sorttable.js
%{contentdir}/%{name}/%{name}.css
%attr(0755,root,root) %dir %{contentdir}/%{name}/images
%{contentdir}/%{name}/images/*.png

%clean
rm -rf %{buildroot}

%changelog
* Mon Dec 21 2015 Django <django@mailserver.guru> - 6.4-1
Add -t | --timezone and TimeZone directive to change the timezone. When set,
SquidAnalyzer will read time from log file as UTC time and will add the
hours specified in the timezone option. This is useful if the log file is
not parsed on a computer with the same timezone than the squid server.

It also included several bug fixes since last release.

  - Fix graphic overlaps that with one of the graphics. Thanks to Daniel Bareiro
    for the report.
  - Add throughput calculation (ratio between bytes and duration) to all reports.
  - Fix missing largest URL in networks detailed report. Thanks to Juan Martin
    for the report.
  - Fix use of network-aliases together with a network include entry that make
    networks disappears from the report. Thanks to Juan Martin for the report.
  - Add -t | --timezone and TimeZone directive to change the timezone. When set,
    SquidAnalyzer will read time from log file as UTC time and will add the
    hours specified in the timezone option. Thanks to Anderson - BR Suporte for
    the feature request.
  - Add support to ufdbGuard log file. squidGuard and ufdbGuard files can be
    given together with squid log file as a list into LogFile configuration
    file or as arguments of command line. Thanks to Martin Hoffmann for the
    feature request.
  - Fix some division by zero. Thanks to cueda for the report.
  - Fix some potential illegal division by zero.
  - Fix negative duration with http like log file when duration is not set (-).
    Thanks to cedua for the report.
  - Add new throughput (Bytes/sec) column in all reports and a throughput graph.
    Thanks to Mike Lerley for the feature request.
  - Allow parsing of xz compressed files. Thanks to Markus Maikis for the patch.
  - Fix bug with include/exclude networks or clients preventing users reports to
    be built. Thanks to Juan Martin for the report.
  - Fix SquidAnalyzer fails to update statistics after cleanup of access.log.
    Thanks to mkhallaf for the report.
  - Limit parsing of ufdbGuard logs to BLOCK line.
  - Replace SquidGuard label by Blocklist as we use more blocklist tools.
  - Update Italian translation file. Thanks to Stefano Cailotto for the update.


* Sat Oct 17 2015 Django <django@mailserver.guru> - 6.3-1
This release adds a new report to show statistics about Denied URLs. It also
allow to add a SquidGuard log to the list of log files and to report blocked
URLs into the Denied reports. It ialso adds a pie chart on SquidGuard ACLs use.

There's also four new configuration directives:

  - UserReport to be able to remove any user related reports but statistics
    about URL and domains will remain.
  - ExcludedCodes to be able to exclude some log entries following the TCP
    code returned.
  - UrlHitsOnly to be able to enable the generation of additional HTML tables
    with top Url per byte and per duration in Top Urls and Domains report.
  - MaxFormatError to not exit immediatly when a bad format error is encountered. 
    SquidAnalyzer will wait MaxFormatError before exiting.

Note that this last directive is disable by default, so if you still want the
three tables in the reports, you must set UrlHitsOnly to 1.

A Catalan translation file has been added to the lang directory.

It also included several bug fixes since last release.

  - Skip immediately lines that squid is not able to tag: TAG_NONE. Thanks to
    David Touzeau for the report.
  - Fix display order when OrderUrl was set in Top Url and Top Domain views.
    Thanks to Wesley Bresson for the report.
  - Convert fr_FR.txt translation file from ISO_8859-1 to UTF8 and change
    charset value. Thanks to zezinho42 for the report.
  - Change order in de_DE.txt of WeekDay to So Mo Di Mi Do Fr Sa, the week
    days in translation file must start with Sunday unlike in calendar.
  - Fix case sensitivity in command line options. Thanks to Pavel Podkorytov
    for the report.
  - Add SquidGuard.current state file to be able to do incremental parsing of
    both squid and squidguard log files without issues.
  - Try to fix bad characters in mime_type field and add MaxFormatError to not
    exit immediatly when a bad format error is encountered. SquidAnalyzer will
    wait MaxFormatError before exiting.
  - Add information about how to parse SquidGuard log together with Squid Cache
    access log file.
  - Add pie chart on SquidGuard ACLs use.
  - Remove redundant regular expressions.
  - Try to fix case when method or code in log file are corrupted with non
    printable characters, should never appears but some injection have been
    reported.
  - Add support for SquidGuard log parsing to report denied ACLs. Thanks to
    Pavel Podkorytov for the feature request.
  - Fix detection of new log file from history when log file was in common
    http format.
  - Fix possible POSIX::strftime error with debug mode activated.
  - Add / at end of WebUrl when it is set but does not terminate with a slash.
  - Remove extra slash in week link, update russian translation file and fix
    some missprint. Thanks to badfiles for the patches.
  - Add Catalan translation file. Thanks to atorrillasmat for the file.
  - misprints, there are two of them. badfiles
  - Add TCP_REDIRECT to be counted as a DENIED tag from log file for users of
    squidGuard/ufdbGuard-style URL rewriters. Thanks to slashdoom for the patch.
  - Force SquidAnalyzer to use locale C internally.
  - Exclusion/Inclusion check when reading data files are limited to rebuild
    otherwise there is too much performance lost.
  - Applied exclusion/inclusion on cumulative reports even if rebuild is not
    used.
  - Fix some issue with rebuild and exclusion.
  - Show more information when a log is skipped because his size is detected
    as lower than expected.
  - Print SquidAnalyzer version when debug mode is used.
  - Add TCP_TUNNEL used by Squid 3.5 for streaming to cache miss statistics.
    Thanks to MangOuste for the report.
  - Apply exclusion/inclusion definitions on old data when rebuild is used.
    Thanks to niccarp for the feature request.
  - Fix unwanted message when QuietMode is enabled.
  - Fix typo that was crashing squid-analyzer. Thanks to Juan Jose Pablos for
    the report.
  - Fix output of benckmark info when debug is not enabled. Thanks to Juan Jose
    Pablos for the report.
  - Fix issue when rebuilding previous data without denied url stat. Thanks to
    Stepan Andreev for the report.
  - Add top denied label to translation file.
  - Add UrlHitsOnly configuration directive to be able to disable the generation
    of tables ordered per byte and duration in Top Urls and Domains report.
    Thanks to Cesar Vazquez for the feature request.
  - Add top denied url statistics. Thanks to tierpod for the featur request.
  - Replace call to localtime() to CORE::localtime() to avoid Time::localtime
    override default behaviour. Thanks to oldnrustyreaper for the report.

* Thu Apr 30 2015 Django <django@mailserver.guru> - 6.2-1
- Initial build for CentOS 7

